#include <stdio.h>
#include <string.h>
#include <usb.h>

// Omnivision IdVendor = 0x05a9
#define IDVENDOR    0x05a9
// Model IdProduct = 0x2800
#define IDPRODUCT   0x2800


int main() {

struct usb_bus *bus;
struct usb_device *device,*cam;
usb_dev_handle	*ucam;
int result;
//char *buffer;
char buffer[1];

buffer[0]=' ';
result=0;


	// Nivell de debug 0 mini 255 maxim
	usb_set_debug(0);
	
	// Inicialitzem USB
	usb_init();

	// Busquem busos USB
	result = usb_find_busses();
	if (result < 0) {
		printf("No hi ha busos USB");
		exit(-1);
	}
	
	// Busquem dispositius als busos USB
	result = usb_find_devices();
	if (result < 0) {
		printf("No hi ha dispositius connectats als busos");
		exit(-1);
	}
	
	
	// Iterem per tots els dispositius de tots els busos buscant la camara
	for ( bus=usb_get_busses(); bus!=NULL; bus=bus->next) {
		for (device = bus->devices; device!=NULL; device = device->next) {
			
			// Hi ha la camara connectada?
			if ((device->descriptor.idVendor == IDVENDOR) &&
				(device->descriptor.idProduct == IDPRODUCT)) {
					
					// cam = variable amb la nostre camara
					cam = device;	
					
					// Informem de que ja em trobat la CAM
					printf("-----> Camara TROBADA!! ");
					printf("idVendor %04X - ",cam->descriptor.idVendor);
					printf("idProduct %04X",cam->descriptor.idProduct);

					// Obrim el dispositiu
					ucam = usb_open(cam);
					
					// Entrem en mode configuraci
					//usb_set_configuration(ucam,cam->config->bConfigurationValue);
					//usb_set_configuration(ucam,1);

					// Llegim el registre 0x13
					result = usb_control_msg (ucam, 0xc0, 0x03, 0x0000, 0x0013,buffer, 0x0001, 5000);
					printf("\nusb_control_msg() returned %d -> 0x%02x", result, buffer[0]);

					// Sobreescribim el valor del registre 0x13
					result = usb_control_msg (ucam, 0x40, 0x02, 0x0015, 0x0013,NULL, 0x0000, 5000);
					
					// Tornem a llegir el valor del registre 0x13
					result = usb_control_msg (ucam, 0xc0, 0x03, 0x0000, 0x0013,buffer, 0x0001, 5000);
					printf("\nusb_control_msg() returned %d -> 0x%02x", result, buffer[0]);
					

					// Tanquem el dispositiu
					usb_close(ucam);

			}//if
		}//for
	}//for

return 0;
}